# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import Ataxx
import Reversi

class DominionGameState(Ataxx.AtaxxGameState):
    """ Exactly like Ataxx, except after moving all enemy pieces "trapped" like in Reversi are also flipped """
    def grid_with_flipped_neighbors(self, ec, pnum):
        nextgrid = self.grid.copy()
        nextgrid[ec] = pnum
        
        for nc in Reversi.flipped_positions_for_move(self.grid, pnum, ec):
            nextgrid[nc] = pnum
        
        for nc,nv in self.enumerate_neighbors(ec):
            if nv>0 and nv!=pnum:
                nextgrid[nc] = pnum
        return nextgrid
    